/* 
   hdr_cbrp.cc

   source route header for CBRP
   Li Jinyang 6/9/99
*/

#include <stdio.h>
#include "hdr_cbrp.h"

int hdr_cbrp::offset_;

static class CBRPHeaderClass : public PacketHeaderClass {
public:
	CBRPHeaderClass() : PacketHeaderClass("PacketHeader/CBRP",
					     sizeof(hdr_cbrp)) {
		offset(&hdr_cbrp::offset_);
	}
	void export_offsets() {
		field_offset("valid_", OFFSET(hdr_cbrp, valid_));
		field_offset("num_addrs_", OFFSET(hdr_cbrp, num_addrs_));
		field_offset("cur_addr_", OFFSET(hdr_cbrp, cur_addr_));
	}
} class_CBRPhdr;

char *
hdr_cbrp::dump()
{
  static char buf[100];
  dump(buf);
  return (buf);
}

void
hdr_cbrp::dump(char *buf)
{
  char *ptr = buf;
  *ptr++ = '[';
  for (int i = 0; i < num_addrs_; i++)
    {
      ptr += sprintf(ptr, "%s%d ",
		     (i == cur_addr_) ? "|" : "",
		     addrs[i].addr);
    }
  *ptr++ = ']';
  *ptr = '\0';
}
